﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány elem összes lehetséges sorrendjét írjam ki? ");
            N = Convert.ToInt32(Console.ReadLine());
        }

        static bool Volt(int i, int j, int[] x)
        {
            int k = 1;
            while (k < i && x[k - 1] != j)
            {
                k++;
            }
            return k < i;
        }

        static void Összes_Sorrend(int i, int N, ref int Db, int[,] Y, int[] x)
        {
            if (i > N)
            {
                for (int j = 0; j < N; j++)
                {   // y[db] = x;
                    Y[Db,j] = x[j];
                }
                Db++;
            }
            else
            {
                for (int j = 1; j <= N; j++)
                {
                    if (!Volt(i, j, x))
                    {
                        x[i - 1] = j;
                        Összes_Sorrend(i + 1, N, ref Db, Y, x);
                    }
                }
            }
        }

        static void Megoldás(int N, out int Db, int[,] Y)
        {
            Db = 0;
            int[] x = new int[N];
            Összes_Sorrend(1,N,ref Db,Y,x);
        }

        static void Kiírás(int N, int Db, int[,] Y)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            Console.Error.WriteLine("Az összes lehetséges sorrend: ");
            for (int i=0;i<Db;i++)
            {
                for (int j=0;j<N;j++)
                {
                    Console.Write(Y[i,j]+" ");
                }
                Console.WriteLine();
            }
        }

        static void Main(string[] args)
        {
            //F1. Összes lehetséges sorrend
            //Maximális elemszám
            const int MaxN = 10;
            const int MaxDb = 10000;
            //A tömb elemszámának deklarálása
            int N;
            //A mátrix deklarálása
            int[,] Y = new int[MaxDb, MaxN];
            //Kimeneti adatok deklarálása
            int Db;
            //Beolvasás
            Beolvasás(out N);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Megoldás(N,out Db,Y);
            //Kiírás
            Kiírás(N, Db, Y);
        }
    }
}
